hdu 1594 (find the max) (绝对值最大值比较大小)

find the max

Time Limit: 1000/1500 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 624    Accepted Submission(s): 292

Problem Description

有一个离散函数f(x),x = {1, 2, ,,,,N},f(x)<2^31。现在要找出2个点i,j, 使得函数在这2点之间的点都在这2点连线下方,且此连线的斜率的绝对值越大越好。

Input

输入包括多个测试实例。每个测试实例包括2行,第一行为一个整数N,2 <= N <= 100000, 然后是N个整数f(x),x=1,2...N,读到文件结束符为止.

Output

对于每个测试实例输出找到的i和j,如果有多个答案,输出字典序最小的一个。

Sample Input

3
1 2 3
3
2 6 4

Sample Output

1 2
1 2

Hint

Hint

use scanf to avoid Time Limit Exceeded

Author

8600

Source

HDU 2007-Spring Programming Contest - Warm Up
(1)

题意:

给定的值是纵坐标,横坐标默认为是从1开始的连续的整数。题意就是求解出绝对值最大的点,使得在选定的两点间的所有点均在直线之下。其他点不考虑。

难点:

就是读题,看懂给定坐标的意思,明白题意 就很好做了。

作者:Ice_Alone

在此感谢两位队友的帮助。

代码如下:

#include<stdio.h>
#include<stdlib.h>
int main()
{
	int n;
	while(~scanf("%d",&n))
	{
		int a,b,max,m,k=1,c,i;
		scanf("%d%d",&a,&b);
		max=abs(a-b);
		for(i=2;i<n;i++)
		{
			scanf("%d",&c);
			m=abs(c-b);
			if(m>max)
			{
				max=m;
				k=i;
			}
			b=c;
		}
		printf("%d %d\n",k,k+1);
	}
	return 0;
} 

hdu 1594 (find the max) (绝对值最大值比较大小)

时间: 2024-10-14 11:48:03

hdu 1594 (find the max) (绝对值最大值比较大小)的相关文章

HDU 1594 find the max

数序问题. 题意是说 一个数列 a1,a2,--ai,--an;  x=i , y = ai:找两个点斜率绝对值!!最大. 第一次没找绝对值,--认真读题... x 每次加1 . 只需要找 相邻的 ai 是否是最大就好了. #include<cstdio> #include<cstring> #include<string> #include<queue> #include<algorithm> #include<map> #incl

HDU 1081 To The Max(DP)

题意  求一个n*n矩阵的最大子矩阵和 HDU 1003 max sum 的升级版   把二维简化为一维就可以用1003的方法去做了  用mat[i][j]存  第i行前j个数的和   那么mat[k][j]-mat[k][i]就表示第k行  第i+1个数到第j个数的和了   再将k从一枚举到n就可以得到这个这个宽度为j-i的最大矩阵和了   然后i,j又分别从1枚举到n就能得到结果了   和1003的方法一样  只是多了两层循环 #include<cstdio> #include<cs

HDU 1081 To The Max 暴力模拟O(n^4) dp优化O(n^3)

原题: http://acm.hdu.edu.cn/showproblem.php?pid=1081 题目大意: 求给定边长的正方形选一个矩形,使它包含的所有元素的值最大. 大家都知道(a+b)^2的展开式,这里的优化就是用了这个原理来做的优化,我们的dp值是我们前i行j列的矩形区域的值. 任意矩形区域的值通过该展开式也能求解,所以我们可以暴力枚举每种以左上角(k,l)到右下角(i,j)的情况. 对于这个题边长是100,4层循环是10^8,因为循环并跑不了这么多,刚好也能卡过去. 代码如下: #

hdu 1081 To The Max(dp+化二维为一维)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1081 To The Max Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8839    Accepted Submission(s): 4281 Problem Description Given a two-dimensional ar

hdu 1754 树状数组求最大值

#include <stdio.h> #include <string> #define MAX(a,b) (a>b?a:b) #define Lowbit(x) (x & (-x)) int idx[200010], num[200010]; /*int Lowbit(int x) { return x&(-x); }*/ /*int MAX(int x, int y) { return x > y ? x:y; }*/ /* 对于区间 [l,r] 把

HDU 1081 To The Max

题目链接 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements in th

hdu 1003,nefu 728 max sum

Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14. Input The first line of the input contains an inte

hdu 1081 To The Max 【最大子矩阵和】

To The Max Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 8882 Accepted Submission(s): 4288 Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is

HDU 1081 to the max 基础DP 好题

To The Max Problem Description Given a two-dimensional array of positive and negative integers, a sub-rectangle is any contiguous sub-array of size 1 x 1 or greater located within the whole array. The sum of a rectangle is the sum of all the elements